// Emacs style mode select   -*- C++ -*- 
//-----------------------------------------------------------------------------
//
// $Id: m_random.c,v 1.5 2001/06/10 21:16:01 bpereira Exp $
//
// Copyright (C) 1993-1996 by id Software, Inc.
// Portions Copyright (C) 1998-2000 by DooM Legacy Team.
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
//
// $Log: m_random.c,v $
// Revision 1.5  2001/06/10 21:16:01  bpereira
// no message
//
// Revision 1.4  2001/03/30 17:12:50  bpereira
// no message
//
// Revision 1.3  2001/01/25 22:15:42  bpereira
// added heretic support
//
// Revision 1.2  2000/02/27 00:42:10  hurdler
// fix CR+LF problem
//
// Revision 1.1.1.1  2000/02/22 20:32:32  hurdler
// Initial import into CVS (v1.29 pr3)
//
//
// DESCRIPTION:
//      Random number LUT.
//
//-----------------------------------------------------------------------------

#include "doomdef.h"
#include "doomtype.h"
#include "m_random.h"
//
// M_Random
// Returns a 0-255 number
//
byte rndtable[256] = {
    0,   8, 109, 220, 222, 241, 149, 107,  75, 248, 254, 140,  16,  66 ,
    74,  21, 211,  47,  80, 242, 154,  27, 205, 128, 161,  89,  77,  36 ,
    95, 110,  85,  48, 212, 140, 211, 249,  22,  79, 200,  50,  28, 188 ,
    52, 140, 202, 120,  68, 145,  62,  70, 184, 190,  91, 197, 152, 224 ,
    149, 104,  25, 178, 252, 182, 202, 182, 141, 197,   4,  81, 181, 242 ,
    145,  42,  39, 227, 156, 198, 225, 193, 219,  93, 122, 175, 249,   0 ,
    175, 143,  70, 239,  46, 246, 163,  53, 163, 109, 168, 135,   2, 235 ,
    25,  92,  20, 145, 138,  77,  69, 166,  78, 176, 173, 212, 166, 113 ,
    94, 161,  41,  50, 239,  49, 111, 164,  70,  60,   2,  37, 171,  75 ,
    136, 156,  11,  56,  42, 146, 138, 229,  73, 146,  77,  61,  98, 196 ,
    135, 106,  63, 197, 195,  86,  96, 203, 113, 101, 170, 247, 181, 113 ,
    80, 250, 108,   7, 255, 237, 129, 226,  79, 107, 112, 166, 103, 241 ,
    24, 223, 239, 120, 198,  58,  60,  82, 128,   3, 184,  66, 143, 224 ,
    145, 224,  81, 206, 163,  45,  63,  90, 168, 114,  59,  33, 159,  95 ,
    28, 139, 123,  98, 125, 196,  15,  70, 194, 253,  54,  14, 109, 226 ,
    71,  17, 161,  93, 186,  87, 244, 138,  20,  52, 123, 251,  26,  36 ,
    17,  46,  52, 231, 232,  76,  31, 221,  84,  37, 216, 165, 212, 106 ,
    197, 242,  98,  43,  39, 175, 254, 145, 190,  84, 118, 222, 187, 136 ,
    120, 163, 236, 249
};

static byte     rndindex = 0;
static byte     prndindex = 0;

#ifndef DEBUGRANDOM

// P_Random is used throughout all the p_xxx game code.
byte P_Random ()
{
    return rndtable[++prndindex];
}

// lot of code used P_Random()-P_Random() since C don't define 
// evaluation order it is compiler depenent so this allow network play 
// between different compilers
int P_SignedRandom ()
{
    int r = P_Random();
    return r-P_Random();
}

#else

byte P_Random2 (char *a,int b)
{
    CONS_Printf("P_Random at : %sp %d\n",a,b);
    return rndtable[++prndindex];
}

int P_SignedRandom2 (char *a,int b)
{
    int r;
    CONS_Printf("P_SignedRandom at : %sp %d\n",a,b);
    r = rndtable[++prndindex];
    return r-rndtable[++prndindex];
}

#endif

byte M_Random (void)
{
    return rndtable[++rndindex];
}

void M_ClearRandom (void)
{
    rndindex = prndindex = 0;
}

// for savegame and join in game
byte P_GetRandIndex(void)
{
    return prndindex;
}

// load game
void P_SetRandIndex(byte rindex)
{
    prndindex = rindex;
}
